module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

	module.exports = __webpack_require__(1);


/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';
	
	var _db = __webpack_require__(2);
	
	var _db2 = _interopRequireDefault(_db);
	
	var _os = __webpack_require__(7);
	
	var _moment = __webpack_require__(3);
	
	var _moment2 = _interopRequireDefault(_moment);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; } /*
	                                                                                                                                                                                                                                                                                                                                                                                                                                                                             Botpress module template. This is your module's entry point.
	                                                                                                                                                                                                                                                                                                                                                                                                                                                                             Please have a look at the docs for more information about config, init and ready.
	                                                                                                                                                                                                                                                                                                                                                                                                                                                                             https://botpress.io/docs
	                                                                                                                                                                                                                                                                                                                                                                                                                                                                           */
	
	
	var cached_config = null;
	//const incomingMiddleware = bp => (event, next) => {
	//    console.log(event);
	//  next()
	//}
	
	
	module.exports = {
	    config: {},
	    init: function () {
	        var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(bp, configurator) {
	            return regeneratorRuntime.wrap(function _callee$(_context) {
	                while (1) {
	                    switch (_context.prev = _context.next) {
	                        case 0:
	                            // This is called before ready.
	                            // At this point your module is just being initialized, it is not loaded yet.
	                            //bp.middlewares.register({
	                            //  name: 'manage.botpress-food-order-module',
	                            //  type: 'incoming',
	                            //  handler: incomingMiddleware(bp),
	                            //  order: 18,
	                            //  module: 'botpress-food-order-module',
	                            //  description: 'Register users from order the food..'
	                            //})
	
	                            (0, _db2.default)(bp).bootstrap().then((0, _db2.default)(bp).listAllDeliveryAddress);
	                            configurator.loadAll().then(function (c) {
	                                return cached_config = c;
	                            });
	
	                        case 2:
	                        case 'end':
	                            return _context.stop();
	                    }
	                }
	            }, _callee, this);
	        }));
	
	        function init(_x, _x2) {
	            return _ref.apply(this, arguments);
	        }
	
	        return init;
	    }(),
	
	    ready: function () {
	        var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(bp, configurator) {
	            var router, config;
	            return regeneratorRuntime.wrap(function _callee2$(_context2) {
	                while (1) {
	                    switch (_context2.prev = _context2.next) {
	                        case 0:
	                            // Your module's been loaded by Botpress.
	                            // Serve your APIs here, execute logic, etc.
	
	                            // Do fancy stuff here :)
	
	                            router = bp.getRouter('botpress-food-order-module', { auth: false });
	                            _context2.next = 3;
	                            return configurator.loadAll();
	
	                        case 3:
	                            config = _context2.sent;
	
	
	                            router.get('/ping', function (req, res, next) {
	                                return res.send('pong');
	                            });
	
	                            router.get('/orderdetails/:orderid', function (req, res) {
	                                var orderid = req.params.orderid;
	                                //see log at botpress's data folder
	                                // bp.logger.info(`MODULE GET /orderdetails/${orderid}`);
	                                // bp.db.kvs.get(orderid).then(orderinfo => {
	                                //     res.send(orderinfo);
	                                // });
	                                (0, _db2.default)(bp).selectShippingAndOrderDetails(orderid).then(function (data) {
	                                    var tmp = {};
	                                    if (data) {
	                                        var orderDetails = JSON.parse(data[0].value);
	                                        var shippingInfo = Object.assign({}, data[0]);
	                                        delete shippingInfo["value"];
	                                        tmp = Object.assign(orderDetails, shippingInfo);
	                                    }
	                                    bp.logger.info('MODULE GET /orderdetails/' + orderid);
	                                    bp.logger.info(JSON.stringify(tmp));
	                                    res.send(tmp);
	                                });
	                            });
	
	                            router.post('/orderdetails', function (req, res) {
	                                var userId = req.body.psid;
	                                var orderID = req.body.orderID;
	                                var paymentID = req.body.paymentID; //paypal's paymentId
	                                //write paymentID to orders table
	                                (0, _db2.default)(bp).updateOrder({ order_id: orderID, paymentID: paymentID }).then();
	                                bp.logger.info("MODULE POST /orderdetails psid >>> ", userId);
	                                bp.events.emit('invoke.thankMessage', { userid: userId });
	                            });
	
	                            //deprecated
	                            router.get('/deliveryaddress', function (req, res) {
	                                (0, _db2.default)(bp).listAllDeliveryAddress().then(function (subs) {
	                                    return res.send(subs);
	                                });
	                            });
	
	                            //deprecated
	                            router.get('/deliveryaddress/:id', function (req, res) {
	                                bp.logger.info('MODULE GET /deliveryaddress/' + req.params.id);
	                                (0, _db2.default)(bp).selectLastDeliveryAddress(req.params.id).then(function (subs) {
	                                    return res.send(subs);
	                                });
	                            });
	
	                            router.get('/shipping/:id', function (req, res) {
	                                (0, _db2.default)(bp).selectShipping(req.params.id).then(function (subs) {
	                                    return res.send(subs);
	                                });
	                            });
	
	                            router.get('/deliveryaddress/:id/:orderid', function (req, res) {
	                                var userId = req.params.id;
	                                var orderId = req.params.orderid;
	                                bp.logger.info('MODULE GET /deliveryaddress/' + userId + '/' + orderId);
	                                (0, _db2.default)(bp).selectDeliveryAddress(userId, orderId).then(function (subs) {
	                                    return res.send(subs);
	                                });
	                            });
	
	                            router.post('/deliveryaddress', function (req, res) {
	                                var userId = req.body.user_id;
	                                var userZipCode = req.body.zip;
	                                var isLastOrder = req.body.is_last_order == "true"; //parse string to boolean
	                                bp.logger.info('MODULE POST /deliveryaddress body >>> ', req.body);
	                                bp.logger.info('MODULE POST /deliveryaddress userId:' + userId + ', isLastOrder: ' + isLastOrder + ', userZipCode: ' + userZipCode);
	
	                                var validDeliveryZipCodes = [80331, 80333, 80335, 80336, 80337, 80339, 80469, 80538, 80539, 80636, 80797, 80798, 80799, 80801, 80802, 80803, 80804, 80807, 81539, 81541, 81543, 81545, 81547, 81549, 81667, 81669, 81671, 81675, 81677, 81679, 81925, 81927, 81929, 85774];
	
	                                if (validDeliveryZipCodes.indexOf(parseInt(userZipCode)) == -1) {
	                                    //Send Take Away QuickReplies
	                                    bp.logger.info("MODULE POST /deliveryaddress : Send Take Away QuickReplies");
	                                    bp.events.emit('invoke.sendTakeAwayQuickReplies', { userid: userId });
	                                } else {
	                                    //Send Food Menu
	                                    if (isLastOrder) {
	                                        bp.logger.info('MODULE POST /deliveryaddress isLastOrder: ' + isLastOrder + ' events emit');
	                                        bp.events.emit('invoke.displayOrderSummary', { userid: userId, islastorder: isLastOrder });
	                                    } else {
	                                        bp.logger.info("MODULE POST /deliveryaddress : Check Delivery Address");
	                                        bp.events.emit('invoke.checkDeliveryAddress', { userid: userId });
	                                    }
	                                }
	
	                                //prevent error when inserting a new record bcause has no is_last_order col
	                                delete req.body.is_last_order;
	                                (0, _db2.default)(bp).upsertShipping(req.body).then(function () {
	                                    return res.sendStatus(200);
	                                });
	                            });
	
	                            router.post('/orderservice', function (req, res) {
	                                var limit = req.body.limit;
	                                var offset = req.body.offset;
	                                var startdate = req.body.startdate;
	                                var enddate = req.body.enddate;
	
	                                var params = {
	                                    limit: limit,
	                                    offset: offset,
	                                    startdate: startdate,
	                                    enddate: enddate
	                                };
	
	                                (0, _db2.default)(bp).queryOrderService(params).then(function (orders) {
	                                    res.send({ result: orders });
	                                });
	                            });
	
	                            router.get('/order/:orderid', function (req, res) {
	                                (0, _db2.default)(bp).selectOrder(req.params.orderid).then(function (subs) {
	                                    return res.send(subs);
	                                });
	                            });
	
	                            router.post('/deliverydatetime', function (req, res) {
	                                console.log('MODULE POST /deliverydatetime islastorder: ' + req.body.islastorder);
	                                var userId = req.body.userid;
	                                var orderId = req.body.ordernum;
	                                var isLastOrder = req.body.islastorder == "true"; //parse string to boolean
	                                var deliveryTime = req.body.deliveryTime + ":00";
	                                var deliveryDateTime = req.body.deliveryDate + "T" + deliveryTime;
	
	                                //When user chooses the time, no need to convert to utc time
	                                //this conversion will be wrong due to the user's time zone.
	                                //it is better to keep theire selected time and save that time in the db.
	                                //the more importance is when reading that time from the db, just create an instance of
	                                //moment and use that time as the utc time.
	                                //deliveryDateTime = moment(deliveryDateTime).utc(); //convert to utc datetime
	                                deliveryDateTime = (0, _moment2.default)(deliveryDateTime);
	
	                                var cDate = deliveryDateTime.year() + '-' + ("0" + (deliveryDateTime.month() + 1)).slice(-2) + '-' + ("0" + deliveryDateTime.date()).slice(-2);
	                                var cTime = ("0" + deliveryDateTime.hour()).slice(-2) + ':' + ("0" + deliveryDateTime.minute()).slice(-2) + ':' + ("0" + deliveryDateTime.second()).slice(-2);
	                                deliveryDateTime = cDate + "T" + cTime;
	
	                                var newDataMapping = {
	                                    order_id: orderId,
	                                    user_id: userId,
	                                    delivery_time: deliveryDateTime
	                                };
	                                console.log('MODULE POST /deliverydatetime newDataMapping >>>', newDataMapping);
	                                console.log('MODULE POST /deliverydatetime deliveryTime >>>', deliveryTime);
	                                console.log('MODULE POST /deliverydatetime deliveryDateTime >>>', deliveryDateTime);
	                                console.log('MODULE POST /deliverydatetime isLastOrder >>>', isLastOrder);
	
	                                (0, _db2.default)(bp).upsertOrder(newDataMapping).then(function () {
	                                    console.log('MODULE /deliverydatetime events emit');
	                                    bp.events.emit('invoke.checkDeliveryAddress', {
	                                        userid: userId,
	                                        orderid: orderId,
	                                        islastorder: isLastOrder,
	                                        deliverydatetime: deliveryDateTime
	                                    });
	                                    res.sendStatus(200);
	                                });
	                            });
	
	                            router.get('/orders', function (req, res) {
	                                bp.logger.info('MODULE GET /orders');
	                                (0, _db2.default)(bp).selectOrders().then(function (orders) {
	                                    return res.send(orders);
	                                });
	                            });
	
	                            router.get('/user/:id', function (req, res) {
	                                var userId = req.params.id;
	                                bp.logger.info('MODULE GET /user/' + userId);
	                                (0, _db2.default)(bp).selectUser(userId).then(function (user) {
	                                    return res.send(user);
	                                });
	                            });
	
	                        case 17:
	                        case 'end':
	                            return _context2.stop();
	                    }
	                }
	            }, _callee2, this);
	        }));
	
	        function ready(_x3, _x4) {
	            return _ref2.apply(this, arguments);
	        }
	
	        return ready;
	    }()
	};

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';
	
	var createMissingColumn = function () {
	    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(bp, tableName, columnName) {
	        var knex;
	        return regeneratorRuntime.wrap(function _callee$(_context) {
	            while (1) {
	                switch (_context.prev = _context.next) {
	                    case 0:
	                        bp.logger.info('MODULE createMissingColumn table: ' + tableName + ', column: ' + columnName);
	                        _context.next = 3;
	                        return bp.db.get();
	
	                    case 3:
	                        knex = _context.sent;
	
	
	                        // knex
	                        // .select('*').from('delivery_addresses')
	                        // .where('user_id', '1315550158553354').orderBy('id', 'desc').limit(1).then(rec => {
	                        //   console.log(rec);
	                        // });
	
	                        knex.schema.hasColumn(tableName, columnName).then(function (exists) {
	                            bp.logger.info('MODULE createMissingColumn exists: ' + exists);
	                            if (!exists) {
	                                bp.logger.info('MODULE createMissingColumn tableName: ' + tableName + ', columnName ' + columnName + ' exists: ' + exists);
	                                knex.schema.table(tableName, function (table) {
	                                    if (/^created_at$/.test(columnName)) {
	                                        table.timestamps();
	                                    } else {
	                                        table.string(columnName);
	                                    }
	                                }).then(); //NOTE: knexjs for alter table calling then is required
	                            }
	                        });
	
	                    case 5:
	                    case 'end':
	                        return _context.stop();
	                }
	            }
	        }, _callee, this);
	    }));
	
	    return function createMissingColumn(_x, _x2, _x3) {
	        return _ref.apply(this, arguments);
	    };
	}();
	
	var _moment = __webpack_require__(3);
	
	var _moment2 = _interopRequireDefault(_moment);
	
	var _lodash = __webpack_require__(4);
	
	var _lodash2 = _interopRequireDefault(_lodash);
	
	var _botpress = __webpack_require__(5);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }
	//import knex from 'knex';
	
	
	var Validate = __webpack_require__(6);
	
	module.exports = function (bp) {
	    return {
	        bootstrap: function bootstrap() {
	            return bp.db.get().then(function (knex) {
	                return initialize(bp, knex);
	            });
	        },
	        listAllDeliveryAddress: function listAllDeliveryAddress() {
	            return bp.db.get().then(_listAllDeliveryAddress);
	        },
	        createDeliveryAddress: function createDeliveryAddress(params) {
	            return bp.db.get().then(function (knex) {
	                return _createDeliveryAddress(bp, knex, params);
	            });
	        },
	        updateDeliveryAddress: function updateDeliveryAddress(psid) {
	            return bp.db.get().then(function (knex) {
	                return _updateDeliveryAddress(bp, knex, psid);
	            });
	        },
	        selectDeliveryAddress: function selectDeliveryAddress(userId, orderId) {
	            return bp.db.get().then(function (knex) {
	                return _selectDeliveryAddress(knex, userId, orderId);
	            });
	        },
	        selectLastDeliveryAddress: function selectLastDeliveryAddress(psid) {
	            return bp.db.get().then(function (knex) {
	                return _selectLastDeliveryAddress(knex, psid);
	            });
	        },
	        upsertDeliveryAddress: function upsertDeliveryAddress(params) {
	            return bp.db.get().then(function (knex) {
	                return _upsertDeliveryAddress(bp, knex, params);
	            });
	        },
	        upsertShipping: function upsertShipping(params) {
	            return bp.db.get().then(function (knex) {
	                return _upsertShipping(bp, knex, params);
	            });
	        },
	        selectShipping: function selectShipping(psid) {
	            return bp.db.get().then(function (knex) {
	                return _selectShipping(knex, psid);
	            });
	        },
	        selectShippingAndOrderDetails: function selectShippingAndOrderDetails(orderid) {
	            return bp.db.get().then(function (knex) {
	                return _selectShippingAndOrderDetails(bp, knex, orderid);
	            });
	        },
	        queryOrderService: function queryOrderService(params) {
	            return bp.db.get().then(function (knex) {
	                return _queryOrderService(bp, knex, params);
	            });
	        },
	        createOrder: function createOrder(params) {
	            return bp.db.get().then(function (knex) {
	                return _createOrder(bp, knex, params);
	            });
	        },
	        updateOrder: function updateOrder(params) {
	            return bp.db.get().then(function (knex) {
	                return _updateOrder(bp, knex, params);
	            });
	        },
	        selectOrder: function selectOrder(orderId) {
	            return bp.db.get().then(function (knex) {
	                return _selectOrder(knex, orderId);
	            });
	        },
	        upsertOrder: function upsertOrder(params) {
	            return bp.db.get().then(function (knex) {
	                return _upsertOrder(bp, knex, params);
	            });
	        },
	        selectOrders: function selectOrders() {
	            return bp.db.get().then(function (knex) {
	                return _selectOrders(knex);
	            });
	        },
	        selectOrderDetails: function selectOrderDetails(orderId) {
	            return bp.db.get().then(function (knex) {
	                return _selectOrderDetails(knex, orderId);
	            });
	        },
	        selectUser: function selectUser(userId) {
	            return bp.db.get().then(function (knex) {
	                return _selectUser(knex, userId);
	            });
	        }
	    };
	};
	
	function initialize(bp, knex) {
	
	    //knex.schema.dropTableIfExists('delivery_address');
	    //knex.schema.dropTableIfExists('order');
	
	    //initialize database
	    (0, _botpress.DatabaseHelpers)(knex).createTableIfNotExists('delivery_addresses', function (table) {
	        table.increments();
	        table.string('fname');
	        table.string('lname');
	        table.string('city');
	        table.string('floor');
	        table.string('name_door_bell');
	        table.string('number');
	        table.string('street');
	        table.string('zip');
	        table.string('state');
	        table.string('country');
	        table.text('comment');
	        table.string('phone');
	        table.string('user_id');
	        table.string('order_id');
	        table.timestamps();
	        //table.foreign('user_id').references('users.userId'); //cannot reference to users.userId because it is not a primary key
	    });
	
	    //NOTE: knexjs for alter table calling then is required
	    createMissingColumn(bp, 'delivery_addresses', 'order_id').then();
	    createMissingColumn(bp, 'delivery_addresses', 'created_at').then();
	
	    createMissingColumn(bp, 'delivery_addresses', 'state').then();
	    createMissingColumn(bp, 'delivery_addresses', 'country').then();
	
	    createMissingColumn(bp, 'orders', 'paymentID').then();
	
	    (0, _botpress.DatabaseHelpers)(knex).createTableIfNotExists('shipping', function (table) {
	        table.increments();
	        table.string('fname');
	        table.string('lname');
	        table.string('city');
	        table.string('floor');
	        table.string('name_door_bell');
	        table.string('number');
	        table.string('street');
	        table.string('zip');
	        table.string('state');
	        table.string('country');
	        table.text('comment');
	        table.string('phone');
	        table.string('user_id');
	        table.timestamps();
	    });
	
	    //NOTE: DONT PUT CODE AFTER BELOW, CODE WILL UNREACHABLE
	
	    return (0, _botpress.DatabaseHelpers)(knex).createTableIfNotExists('orders', function (table) {
	        //table.increments();
	        //table.increments('id').primary();
	        table.string('order_id', 11);
	        table.string('user_id');
	        table.integer('type'); //0:internet, 1:mobile, 99:cancellation
	        table.integer('shopid');
	        table.dateTime('order_time');
	        table.dateTime('delivery_time');
	        table.integer('delivery_type'); //0:delivery, 1:takeaway
	        table.integer('payment'); //0:cash, 202:online/paypal
	        table.string('paymentID');
	
	        table.boolean('is_delivered');
	        table.boolean('is_paid');
	
	        table.timestamps(); //this will create 2 columns: created_at and updated_at
	        //table.foreign('user_id').references('users.userId'); //cannot reference to users.userId because it is not a primary key
	    }).then(function () {
	        // return bp.db.get()
	        // .then(knex => 
	        //   knex.schema.alterTable('order', function(t) {
	        //     t.unique(['user_id', 'order_id'])
	        //   })
	        // )
	        //.then(order => /* do stuff */);
	    });
	
	    // users table
	    // use kvs instead
	
	    //end initialize database
	}
	
	function _listAllDeliveryAddress(knex) {
	    return knex('delivery_addresses').orderBy('id', 'desc').limit(20);
	}
	
	function _createDeliveryAddress(bp, knex, params) {
	    var createdAt = params['created_at'];
	    bp.logger.info('MODULE createDeliveryAddress params: ' + params);
	    if (createdAt == undefined) {
	        var currentDateTime = (0, _moment2.default)().utc().toISOString();
	        params.created_at = currentDateTime;
	        params.updated_at = currentDateTime;
	    }
	    return knex('delivery_addresses').insert(params).then(function (id) {
	        bp.logger.info('db.js createDeliveryAddress returned id >>> ', id);
	    });
	}
	
	function _updateDeliveryAddress(bp, knex, userId) {
	    return knex('delivery_addresses').where('user_id', userId).update(userId).then(function (id) {
	        bp.logger.info('db.js updateDeliveryAddress returned id >>> ', id);
	    });
	}
	
	function _selectDeliveryAddress(knex, userId, orderId) {
	    var params = {
	        'user_id': userId,
	        'order_id': orderId
	    };
	    return knex.select('*').from('delivery_addresses').where(params);
	}
	
	function _selectLastDeliveryAddress(knex, userId) {
	    return knex.select('*').from('delivery_addresses').where('user_id', userId).orderBy('id', 'desc').limit(1);
	}
	
	function _upsertDeliveryAddress(bp, knex, params) {
	    return knex('delivery_addresses').where({ 'user_id': params.user_id, 'order_id': params.order_id }).update(params).then(function (id) {
	        bp.logger.info("db.js upsertDeliveryAddress returned id  >>> ", id);
	        if (id == 0) {
	            // id = 0 is not update
	            return _createDeliveryAddress(bp, knex, params);
	        }
	    });
	}
	
	function _upsertShipping(bp, knex, params) {
	    var _params = Object.assign({}, params);
	    delete _params["order_id"];
	    return knex('shipping').where({ 'user_id': _params.user_id }).update(_params).then(function (id) {
	        bp.logger.info("db.js upsertShipping returned id  >>> ", id);
	        if (id == 0 || id == undefined) {
	            // id = 0 is not update
	            bp.logger.info("db.js createdShipping  >>> ", id);
	            return createShipping(bp, knex, _params);
	        }
	    }).catch(function (err) {
	        console.error(err);
	    });
	}
	
	function createShipping(bp, knex, params) {
	    var createdAt = params['created_at'];
	    bp.logger.info('MODULE createShipping params: ' + params);
	    if (createdAt == undefined) {
	        var currentDateTime = (0, _moment2.default)().utc().toISOString();
	        params.created_at = currentDateTime;
	        params.updated_at = currentDateTime;
	    }
	    return knex('shipping').insert(params).then(function (id) {
	        bp.logger.info('db.js createShipping returned id >>> ', id);
	    });
	}
	
	function _selectShipping(knex, userId) {
	    return knex.select('*').from('shipping').where('user_id', userId).orderBy('id', 'desc').limit(1);
	}
	
	function _selectShippingAndOrderDetails(bp, knex, orderid) {
	    return knex('kvs as k').innerJoin('delivery_addresses as da', 'k.key', 'da.order_id').select('k.value', 'da.*').where('da.order_id', orderid);
	}
	
	function _queryOrderService(bp, knex, params) {
	    var limit = params.limit;
	    var offset = params.offset;
	    var startdate = params.startdate;
	    var enddate = params.enddate;
	
	    // return knex('users as u')
	    // .innerJoin('orders as o', 'o.user_id', 'u.userId')
	    // .innerJoin('kvs as k', 'k.key', 'o.order_id')
	    // .innerJoin('delivery_addresses as d', 'd.user_id', 'u.userId')
	    // .select('u.*', 'o.*', 'd.*','k.value as items').limit(limit).offset(offset);
	
	    //https://shizoo.social7-wifi.com/api/botpress-food-order-module/orderservice
	    /*
	    GET https://shizoo.social7-wifi.com/webview/orderservice?startdate=07-10-2018
	    Authorization
	      Type: Basic Auth
	      Username: admin
	      Password: shizoo$24
	    */
	
	    /*
	    SELECT 
	      DISTINCT(o.order_id),
	      u.UserId as user_id, 
	      u.first_name, 
	      u.last_name, 
	      u.gender, 
	      o.order_id, 
	      o.type, 
	      o.shopid, 
	      o.order_time, 
	      o.delivery_time, 
	      o.delivery_type, 
	      o.payment, 
	      o.created_at, 
	      d.fname, 
	      d.lname, 
	      d.city, 
	      d.floor, 
	      d.name_door_bell, 
	      d.number,
	      d.street, 
	      d.zip, 
	      d.comment, 
	      d.phone, 
	      k.value as items 
	    FROM orders as o 
	    INNER JOIN kvs as k on k.key = o.order_id
	    INNER JOIN delivery_addresses as d on d.order_id = o.order_id
	    INNER JOIN users as u on u.userId = o.user_id
	    WHERE o.created_at >= '2018-07-10T00:00:00'
	    AND o.created_at <= '2018-07-10T23:59:59';
	    */
	
	    var selectedColumns = ['u.userId as user_id', 'u.first_name', 'u.last_name', 'u.gender', 'o.order_id', 'o.type', 'o.shopid', 'o.order_time', 'o.delivery_time', 'o.delivery_type', 'o.payment', 'o.created_at', 'd.fname', 'd.lname', 'd.city', 'd.floor', 'd.name_door_bell', 'd.number', 'd.street', 'd.zip', 'd.comment', 'd.phone', 'k.value as items'];
	
	    return knex('orders as o').distinct('o.order_id').innerJoin('kvs as k', 'k.key', 'o.order_id').innerJoin('delivery_addresses as d', 'd.order_id', 'o.order_id').innerJoin('users as u', 'u.userId', 'o.user_id').select(selectedColumns).where('o.created_at', '>=', startdate).andWhere('o.created_at', '<=', enddate).limit(limit).offset(offset);
	}
	
	function _selectOrder(knex, orderId) {
	    return knex.select('*').from('orders').where('order_id', orderId);
	}
	
	function _createOrder(bp, knex, params) {
	    return knex('orders').insert(params).then(function (id) {
	        bp.logger.info('db.js createOrder returned id >>> ', id);
	    });
	}
	
	function _updateOrder(bp, knex, params) {
	    return knex('orders').where('order_id', params.order_id).update(params).then(function (id) {
	        bp.logger.info('db.js updateOrder returned id >>> ', id);
	    });
	}
	
	function _upsertOrder(bp, knex, params) {
	    return knex('orders').where('order_id', params.order_id).update(params).then(function (id) {
	        bp.logger.info("db.js upsertOrder returned id  >>> ", id);
	        if (id == 0) {
	            // id = 0 is not update
	            return _createOrder(bp, knex, params);
	        }
	    });
	}
	
	function _selectOrders(knex) {
	    //return knex.select('*').from('orders')
	
	    //Return any orders which have or don't have order items
	    // return knex('orders as o')
	    // .leftJoin('kvs as k', 'k.key', 'o.order_id')
	    // .select('o.*', 'k.value as items');
	
	    //Return any orders which have order items
	    return knex('orders as o').innerJoin('kvs as k', 'k.key', 'o.order_id').select('o.*', 'k.value as items');
	}
	
	function _selectOrderDetails(knex, orderId) {
	    return knex.select('value').from('kvs').where('order_id', orderId);
	}
	
	function _selectUser(knex, userId) {
	    return knex.select('*').from('users').where('userId', userId);
	}

/***/ }),
/* 3 */
/***/ (function(module, exports) {

	module.exports = require("moment");

/***/ }),
/* 4 */
/***/ (function(module, exports) {

	module.exports = require("lodash");

/***/ }),
/* 5 */
/***/ (function(module, exports) {

	module.exports = require("botpress");

/***/ }),
/* 6 */
/***/ (function(module, exports) {

	module.exports = require("validate-arguments");

/***/ }),
/* 7 */
/***/ (function(module, exports) {

	module.exports = require("os");

/***/ })
/******/ ]);
//# sourceMappingURL=node.bundle.js.map